// DcmFile.h: interface for the DcmFile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DCMFILE_H__3CCC0569_E60E_11D2_B075_BDACC3676533__INCLUDED_)
#define AFX_DCMFILE_H__3CCC0569_E60E_11D2_B075_BDACC3676533__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FileMetaInfo.h"

class DcmFile : public std::fstream  
{
   FileMetaInfo m_fmi;
public:
	// CREATORS
	DcmFile();
	DcmFile(const std::string& classUID, const std::string& instUID, TS ts);

	// I/O
   bool isPart10() { return FileMetaInfo::isPart10(*this); }
   bool read(DataSet& ds);
   bool readACR(DataSet& ds);
   bool readRawData(DataSet& ds, TS ts = TS::IMPL_VR_LE);
   bool write(const DataSet& ds);
   bool writeRawData(const DataSet& ds, TS ts = TS::IMPL_VR_LE);

   // MANIPULATORS
   FileMetaInfo& metaInfo() { return m_fmi; }

   // ACCESSORS
   const FileMetaInfo& metaInfo() const { return m_fmi; }
};

#endif // !defined(AFX_DCMFILE_H__3CCC0569_E60E_11D2_B075_BDACC3676533__INCLUDED_)
