/****************************************************************************
          Copyright (C) 1998, Karl Franzens University, Graz

          THIS SOFTWARE IS MADE AVAILABLE, AS IS, AND THE KARL FRANZENS
          UNIVERSITY DOES NOT MAKE ANY WARRANTY ABOUT THE SOFTWARE, ITS
          PERFORMANCE, ITS MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR
          USE, FREEDOM FROM ANY COMPUTER DISEASES OR ITS CONFORMITY TO ANY
          SPECIFICATION. THE ENTIRE RISK AS TO QUALITY AND PERFORMANCE OF
          THE SOFTWARE IS WITH THE USER.

          Copyright of the software and supporting documentation is
          owned by the Karl Franzens University, and free access
          is hereby granted as a license to use this software, copy this
          software and prepare derivative works based upon this software.
          However, any distribution of this software source code or
          supporting documentation or derivative works (source code and
          supporting documentation) must include this copyright notice.
****************************************************************************/

/***************************************************************************
 *
 * Karl Franzens University, Graz
 * UCDMC99 DICOM Network Transport Libraries 
 * Version 0.1 Beta
 *
 * Technical Contact: gunter.zeilinger@kfunigraz.ac.at
 *
 ***************************************************************************/

#ifndef __DECODER2_H__
#define __DECODER2_H__

#include "DataSet.h"
#include "TS.h"

class Decoder2 
{
public:
	// CREATORS
	Decoder2(std::istream& is, TS ts)
		: m_is(is), m_ts(ts) {}

	// MANIPULATORS
	UINT32 read(DataSet::value_type& rhs);
	UINT32 read(DataSet& rhs, UINT32 len = 0xffffffff);
	UINT32 read(Sequence* pSeq, UINT32 len);
   UINT32 readItem(DataSet& ds, Tag& tag);
   UINT32 read32();
   UINT16 read16();
	Tag readTag();

	// ACCESSORS
private:
	std::istream& m_is;
	TS m_ts;
	enum { MAX_VALID_LENGTH = 80000000 };
};

#endif //__DECODER2_H__