/****************************************************************************
          Copyright (C) 1998, Karl Franzens University, Graz

          THIS SOFTWARE IS MADE AVAILABLE, AS IS, AND THE KARL FRANZENS
          UNIVERSITY DOES NOT MAKE ANY WARRANTY ABOUT THE SOFTWARE, ITS
          PERFORMANCE, ITS MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR
          USE, FREEDOM FROM ANY COMPUTER DISEASES OR ITS CONFORMITY TO ANY
          SPECIFICATION. THE ENTIRE RISK AS TO QUALITY AND PERFORMANCE OF
          THE SOFTWARE IS WITH THE USER.

          Copyright of the software and supporting documentation is
          owned by the Karl Franzens University, and free access
          is hereby granted as a license to use this software, copy this
          software and prepare derivative works based upon this software.
          However, any distribution of this software source code or
          supporting documentation or derivative works (source code and
          supporting documentation) must include this copyright notice.
****************************************************************************/

/***************************************************************************
 *
 * Karl Franzens University, Graz
 * UCDMC99 DICOM Network Transport Libraries 
 * Version 0.1 Beta
 *
 * Technical Contact: gunter.zeilinger@kfunigraz.ac.at
 *
 ***************************************************************************/

#ifndef __DUMPER_H__
#define __DUMPER_H__

#include "DataSet.h"

class Dumper
{
public:
	struct Scheme
	{
		char noPrintCh;		// default: '#'
		UINT32 truncChar;	// default: 64
		UINT32 truncByte;	// default: 32
		UINT32 truncWord;	// default: 16
		const char* truncSign;	// default: ".."
		const char* fOB;		// default: "%.2x "
		const char* fOW;		// default: "%.4x "
		const char* fUS;		// default: "%.4x "
		const char* fUL;		// default: "%.8x "
		const char* fSS;		// default: "%+d "
		const char* fSL;		// default: "%+d "
		const char* fFL;		// default: "%g "
		const char* fFD;		// default: "%g "
		const char* fTag;		// default: "(%.4x,%.4x)"
		const char* fLen;		// default: ",%d", "" -> no output of len
		const char* fVR;		// default: ",%c%c", "" -> no output of VR
		const char* fName;		// default: ",%s", "" -> no output of name
		const char* unknown;	// default: "?????????????"
		const char* prefixSQ;	// default: "<", "" -> no output of sequence container element
		const char* prefixVal;	// default: "\t"
		const char* endOfElem;	// default: "\n"
		const char* valSQelem;	// default: "(null)"
		VR	fVR_UNas;		// default: VR_OB, define value format in the case of VR_UN 
	};
	static const Scheme defaultScheme;
	// CREATORS
	Dumper(std::ostream& os, const Scheme& scheme = defaultScheme);

	// MANIPULATORS

	// WRITERS
	void write(const char* s);
	void write(const DataSet::value_type& elem);
	void write(const DataSet& ds);
	void write(const Sequence* pSQ);
protected:
	std::ostream& m_os;
	UINT m_SQlevel;
	const Scheme& m_scheme;
};


#endif //__DUMPER_H__