/****************************************************************************
          Copyright (C) 1998, Karl Franzens University, Graz

          THIS SOFTWARE IS MADE AVAILABLE, AS IS, AND THE KARL FRANZENS
          UNIVERSITY DOES NOT MAKE ANY WARRANTY ABOUT THE SOFTWARE, ITS
          PERFORMANCE, ITS MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR
          USE, FREEDOM FROM ANY COMPUTER DISEASES OR ITS CONFORMITY TO ANY
          SPECIFICATION. THE ENTIRE RISK AS TO QUALITY AND PERFORMANCE OF
          THE SOFTWARE IS WITH THE USER.

          Copyright of the software and supporting documentation is
          owned by the Karl Franzens University, and free access
          is hereby granted as a license to use this software, copy this
          software and prepare derivative works based upon this software.
          However, any distribution of this software source code or
          supporting documentation or derivative works (source code and
          supporting documentation) must include this copyright notice.
****************************************************************************/

/***************************************************************************
 *
 * Karl Franzens University, Graz
 * UCDMC2 DICOM Network Transport Libraries 
 * Version 0.1 Beta
 *
 * Technical Contact: gunter.zeilinger@kfunigraz.ac.at
 *
 ***************************************************************************/

#ifndef __ENCODER2_H__
#define __ENCODER2_H__

#include "DataSet.h"
#include "TS.h"

class Encoder2
{
	std::ostream& m_os;
	TS m_ts;
public:
	// CREATORS
	Encoder2(std::ostream& os, TS ts)
	:	m_os(os), m_ts(ts) {}
	
	// MANIPULATORS
	UINT32 write(const DataSet::value_type& elem);
	UINT32 write(const Value& val);
	UINT32 write(const DataSet& ds);
   UINT32 writeItem(const DataSet& ds);
	UINT32 write(const Sequence* pSeq);
	UINT32 write16(UINT16 val);
	UINT32 write32(UINT32 val);
	UINT32 writeTag(const Tag& tag);
private:
	UINT32 getGrLen(const DataSet& ds);
};

#endif //__ENCODER2_H__