#ifndef __FILEMETAINFO_H__
#define __FILEMETAINFO_H__
/****************************************************************************
          Copyright (C) 1998, Karl Franzens University, Graz

          THIS SOFTWARE IS MADE AVAILABLE, AS IS, AND THE KARL FRANZENS
          UNIVERSITY DOES NOT MAKE ANY WARRANTY ABOUT THE SOFTWARE, ITS
          PERFORMANCE, ITS MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR
          USE, FREEDOM FROM ANY COMPUTER DISEASES OR ITS CONFORMITY TO ANY
          SPECIFICATION. THE ENTIRE RISK AS TO QUALITY AND PERFORMANCE OF
          THE SOFTWARE IS WITH THE USER.

          Copyright of the software and supporting documentation is
          owned by the Karl Franzens University, and free access
          is hereby granted as a license to use this software, copy this
          software and prepare derivative works based upon this software.
          However, any distribution of this software source code or
          supporting documentation or derivative works (source code and
          supporting documentation) must include this copyright notice.
****************************************************************************/

/***************************************************************************
 *
 * Karl Franzens University, Graz
 * UCDMC99 DICOM Network Transport Libraries 
 * Version 0.1 Beta
 *
 * Technical Contact: gunter.zeilinger@kfunigraz.ac.at
 *
 ***************************************************************************/

#include "DataSet.h"
#include "TS.h"

class FileMetaInfo : public DataSet  
{
   char m_preamble[128];
	TS m_ts;
	static const std::string VERSION;
public:
	bool readACRFrom(std::istream& is);
	// CREATORS
	FileMetaInfo();
	FileMetaInfo(const std::string& classUID, const std::string& instUID, TS ts);

   // I/O
   bool readFrom(std::istream& is);
	bool writeTo(std::ostream& os) const;
   static bool isPart10(std::istream& is);

	// MANIPULATORS
   char* preamble() { return m_preamble; }

	// ACCESSORS
   const char* preamble() const { return m_preamble; }
	bool verify() const;
	TS getTS() const { return m_ts; }
};

#endif //__FILEMETAINFO_H__