/****************************************************************************
          Copyright (C) 1998, Karl Franzens University, Graz

          THIS SOFTWARE IS MADE AVAILABLE, AS IS, AND THE KARL FRANZENS
          UNIVERSITY DOES NOT MAKE ANY WARRANTY ABOUT THE SOFTWARE, ITS
          PERFORMANCE, ITS MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR
          USE, FREEDOM FROM ANY COMPUTER DISEASES OR ITS CONFORMITY TO ANY
          SPECIFICATION. THE ENTIRE RISK AS TO QUALITY AND PERFORMANCE OF
          THE SOFTWARE IS WITH THE USER.

          Copyright of the software and supporting documentation is
          owned by the Karl Franzens University, and free access
          is hereby granted as a license to use this software, copy this
          software and prepare derivative works based upon this software.
          However, any distribution of this software source code or
          supporting documentation or derivative works (source code and
          supporting documentation) must include this copyright notice.
****************************************************************************/

/***************************************************************************
 *
 * Karl Franzens University, Graz
 * UCDMC99 DICOM Network Transport Libraries 
 * Version 0.1 Beta
 *
 * Technical Contact: gunter.zeilinger@kfunigraz.ac.at
 *
 ***************************************************************************/

#include "base.hpp"
#include "TS.h"

static const char* TS_UID[] =
{
  UID_IMPL_VR_LE_TRANSFER_SYNTAX,
  UID_EXPL_VR_LE_TRANSFER_SYNTAX,
  UID_DEFLATED_EXPL_VR_LE_TRANSFER_SYNTAX,
  UID_EXPL_VR_BE_TRANSFER_SYNTAX
};
const int SIZEOF_TS_UID = sizeof(TS_UID)/sizeof(TS_UID[0]);

TS::TS(const std::string& uid)
{
  m_type = Type(std::find(TS_UID, TS_UID + SIZEOF_TS_UID, uid) - TS_UID);
}

const char* TS::getUID() const
{
  return TS_UID[m_type];
}

bool TS::isExplicitVR() const
{
  static const bool TAB_IS_EXPLICIT_VR[] = { false, true, true, true };
  return TAB_IS_EXPLICIT_VR[m_type];
}

bool TS::isBigEndian() const
{
  static const bool TAB_IS_BIG_ENDIAN[] = { false, false, false, true };
  return TAB_IS_BIG_ENDIAN[m_type];
}

bool TS::isDeflated() const
{
  static const bool TAB_IS_DEFLATED[] = { false, false, true, false };
  return TAB_IS_DEFLATED[m_type];
}
