/****************************************************************************
          Copyright (C) 1998, Karl Franzens University, Graz

          THIS SOFTWARE IS MADE AVAILABLE, AS IS, AND THE KARL FRANZENS
          UNIVERSITY DOES NOT MAKE ANY WARRANTY ABOUT THE SOFTWARE, ITS
          PERFORMANCE, ITS MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR
          USE, FREEDOM FROM ANY COMPUTER DISEASES OR ITS CONFORMITY TO ANY
          SPECIFICATION. THE ENTIRE RISK AS TO QUALITY AND PERFORMANCE OF
          THE SOFTWARE IS WITH THE USER.

          Copyright of the software and supporting documentation is
          owned by the Karl Franzens University, and free access
          is hereby granted as a license to use this software, copy this
          software and prepare derivative works based upon this software.
          However, any distribution of this software source code or
          supporting documentation or derivative works (source code and
          supporting documentation) must include this copyright notice.
****************************************************************************/

/***************************************************************************
 *
 * Karl Franzens University, Graz
 * UCDMC99 DICOM Network Transport Libraries 
 * Version 0.1 Beta
 *
 * Technical Contact: gunter.zeilinger@kfunigraz.ac.at
 *
 ***************************************************************************/
#ifndef __TS_H__
#define __TS_H__

#include "Uid.h"

class TS
{
public:
  enum Type { IMPL_VR_LE, EXPL_VR_LE, DEFLATED_EXPL_VR_LE, EXPL_VR_BE, NOT_SUPPORTED }; 
  TS(Type type = NOT_SUPPORTED) : m_type(type) {}
  TS(const std::string& uid);
  TS(const TS& ts) : m_type(ts.m_type) {}

  TS& operator=(const TS& ts) { m_type = ts.m_type; return *this; }

  const char* getUID() const;
  bool isExplicitVR() const;
  bool isBigEndian() const;
  bool isDeflated() const;
  friend bool operator==(const TS& lhs, const TS& rhs) {
    return lhs.m_type == rhs.m_type; }
  friend bool operator!=(const TS& lhs, const TS& rhs) {
    return lhs.m_type != rhs.m_type; }
private:
  Type m_type;
};

#endif //__TS_H__