/****************************************************************************
          Copyright (C) 1998, Karl Franzens University, Graz

          THIS SOFTWARE IS MADE AVAILABLE, AS IS, AND THE KARL FRANZENS
          UNIVERSITY DOES NOT MAKE ANY WARRANTY ABOUT THE SOFTWARE, ITS
          PERFORMANCE, ITS MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR
          USE, FREEDOM FROM ANY COMPUTER DISEASES OR ITS CONFORMITY TO ANY
          SPECIFICATION. THE ENTIRE RISK AS TO QUALITY AND PERFORMANCE OF
          THE SOFTWARE IS WITH THE USER.

          Copyright of the software and supporting documentation is
          owned by the Karl Franzens University, and free access
          is hereby granted as a license to use this software, copy this
          software and prepare derivative works based upon this software.
          However, any distribution of this software source code or
          supporting documentation or derivative works (source code and
          supporting documentation) must include this copyright notice.
****************************************************************************/

/***************************************************************************
 *
 * Karl Franzens University, Graz
 * UCDMC99 DICOM Network Transport Libraries 
 * Version 0.1 Beta
 *
 * Technical Contact: gunter.zeilinger@kfunigraz.ac.at
 *
 ***************************************************************************/

#ifndef __UID_H__
#define __UID_H__

typedef std::string UID;

const char UID_SUNNYBROOK_YAFFEGRP_PREFIX[] = "1.2.840.416.480.5705";

const char UID_VERIFICATION_SOP_CLASS[]	        = "1.2.840.10008.1.1";
const char UID_IMPL_VR_LE_TRANSFER_SYNTAX[]	= "1.2.840.10008.1.2";
const char UID_EXPL_VR_LE_TRANSFER_SYNTAX[]	= "1.2.840.10008.1.2.1";
const char UID_DEFLATED_EXPL_VR_LE_TRANSFER_SYNTAX[]	= "1.2.840.10008.1.2.1.99";
const char UID_EXPL_VR_BE_TRANSFER_SYNTAX[]	= "1.2.840.10008.1.2.2";

const char UID_MEDIA_DIR_STORAGE_SOP_CLASS[]	= "1.2.840.10008.1.3.10";

const char UID_APPLICATION_CONTEXT[]		= "1.2.840.10008.3.1.1.1";

const char UID_MODALITY_PPS_SOP_CLASS[]		= "1.2.840.10008.3.1.2.3.3";

const char UID_CR_IMAGE_STORAGE_SOP_CLASS[]	    = "1.2.840.10008.5.1.4.1.1.1";
const char UID_CT_IMAGE_STORAGE_SOP_CLASS[]	    = "1.2.840.10008.5.1.4.1.1.2";
const char UID_USOLD_MF_IMAGE_STORAGE_SOP_CLASS[]  = "1.2.840.10008.5.1.4.1.1.3";
const char UID_US_MF_IMAGE_STORAGE_SOP_CLASS[]  = "1.2.840.10008.5.1.4.1.1.3.1";
const char UID_MR_IMAGE_STORAGE_SOP_CLASS[]	    = "1.2.840.10008.5.1.4.1.1.4";
const char UID_USOLD_IMAGE_STORAGE_SOP_CLASS[]	= "1.2.840.10008.5.1.4.1.1.6";
const char UID_US_IMAGE_STORAGE_SOP_CLASS[]	    = "1.2.840.10008.5.1.4.1.1.6.1";
const char UID_SC_IMAGE_STORAGE_SOP_CLASS[]	    = "1.2.840.10008.5.1.4.1.1.7";
const char UID_NM_IMAGE_STORAGE_SOP_CLASS[]	    = "1.2.840.10008.5.1.4.1.1.20";
const char UID_XA_IMAGE_STORAGE_SOP_CLASS[]	    = "1.2.840.10008.5.1.4.1.1.12.1";
const char UID_XRF_IMAGE_STORAGE_SOP_CLASS[]	= "1.2.840.10008.5.1.4.1.1.12.2";
const char UID_XA2_IMAGE_STORAGE_SOP_CLASS[]	= "1.2.840.10008.5.1.4.1.1.12.3";
const char UID_PET_IMAGE_STORAGE_SOP_CLASS[]	= "1.2.840.10008.5.1.4.1.1.128";
const char UID_DX_PRES_IMAGE_STORAGE_SOP_CLASS[]	= "1.2.840.10008.5.1.4.1.1.1.1";
const char UID_DX_PROC_IMAGE_STORAGE_SOP_CLASS[]	= "1.2.840.10008.5.1.4.1.1.1.1.1";
const char UID_MAMMO_PRES_IMAGE_STORAGE_SOP_CLASS[]	= "1.2.840.10008.5.1.4.1.1.1.2";
const char UID_MAMMO_PROC_IMAGE_STORAGE_SOP_CLASS[]	= "1.2.840.10008.5.1.4.1.1.1.2.1";
const char UID_RT_STRUCTURE_SET_STORAGE_SOP_CLASS[]	= "1.2.840.10008.5.1.4.1.1.481.3";

const char UID_BASIC_TEXT_SR_STORAGE_SOP_CLASS[]	= "1.2.840.10008.5.1.4.1.1.88.11";
const char UID_ENHANCED_SR_STORAGE_SOP_CLASS[]	= "1.2.840.10008.5.1.4.1.1.88.22";
const char UID_COMPREHENSIVE_SR_STORAGE_SOP_CLASS[]	= "1.2.840.10008.5.1.4.1.1.88.33";

const char UID_INTRAORAL_PRES_IMAGE_STORAGE_SOP_CLASS[]	= "1.2.840.10008.5.1.4.1.1.1.3";
const char UID_INTRAORAL_PROC_IMAGE_STORAGE_SOP_CLASS[]	= "1.2.840.10008.5.1.4.1.1.1.3.1";

const char UID_PAT_QR_FIND_SOP_CLASS[]		= "1.2.840.10008.5.1.4.1.2.1.1";
const char UID_PAT_QR_MOVE_SOP_CLASS[]		= "1.2.840.10008.5.1.4.1.2.1.2";
const char UID_PAT_QR_GET_SOP_CLASS[]		= "1.2.840.10008.5.1.4.1.2.1.3";
const char UID_STUDY_QR_FIND_SOP_CLASS[]	= "1.2.840.10008.5.1.4.1.2.2.1";
const char UID_STUDY_QR_MOVE_SOP_CLASS[]	= "1.2.840.10008.5.1.4.1.2.2.2";
const char UID_STUDY_QR_GET_SOP_CLASS[]		= "1.2.840.10008.5.1.4.1.2.2.3";
const char UID_PSONLY_QR_FIND_SOP_CLASS[]	= "1.2.840.10008.5.1.4.1.2.3.1";
const char UID_PSONLY_QR_MOVE_SOP_CLASS[]	= "1.2.840.10008.5.1.4.1.2.3.2";
const char UID_PSONLY_QR_GET_SOP_CLASS[]	= "1.2.840.10008.5.1.4.1.2.3.3";

const char UID_MODALITY_WORKLIST_SOP_CLASS[]	= "1.2.840.10008.5.1.4.31";

#endif //__UID_H__