/****************************************************************************
          Copyright (C) 1995, University of California, Davis

          THIS SOFTWARE IS MADE AVAILABLE, AS IS, AND THE UNIVERSITY
          OF CALIFORNIA DOES NOT MAKE ANY WARRANTY ABOUT THE SOFTWARE, ITS
          PERFORMANCE, ITS MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR
          USE, FREEDOM FROM ANY COMPUTER DISEASES OR ITS CONFORMITY TO ANY
          SPECIFICATION. THE ENTIRE RISK AS TO QUALITY AND PERFORMANCE OF
          THE SOFTWARE IS WITH THE USER.

          Copyright of the software and supporting documentation is
          owned by the University of California, and free access
          is hereby granted as a license to use this software, copy this
          software and prepare derivative works based upon this software.
          However, any distribution of this software source code or
          supporting documentation or derivative works (source code and
          supporting documentation) must include this copyright notice.
****************************************************************************/

/***************************************************************************
 *
 * University of California, Davis
 * UCDMC DICOM Network Transport Libraries
 * Version 0.1 Beta
 *
 * Technical Contact: mhoskin@ucdavis.edu
 *
 ***************************************************************************/
/***************************************************************************
 *
 * Karl Franzens University, Graz
 * UCDMC99 DICOM Network Transport Libraries 
 * Version 0.1 Beta
 *
 * Technical Contact: gunter.zeilinger@kfunigraz.ac.at
 * Modifications signed with [gz]
 ***************************************************************************/

// Base Class Include Header
#if	__MWERKS__
// Macintosh Compiling is a little different.  We don't pass in a system/endian
// on the "command line", hence, we detect the MetroWorks compiler.
#	define	MAC
#	define	NATIVE_ENDIAN	2
#endif
#ifdef	MAC
#	include	<stdio.h>
#	include	<string.h>
#	include	"macsock.h"
#else
extern	"C"
	{
#	include	<stdio.h>
#	include	<string.h>
	}
#endif
#ifdef WIN32
#define	NATIVE_ENDIAN	1
#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
#ifdef _AFXDLL
#include <afx.h>
#else
#include <windows.h>

#include <crtdbg.h>	
#ifndef ASSERT
#define ASSERT _ASSERT// define _ASSERT Macros [gz] 
#endif

#endif	// _AFXDLL
#include <winsock.h>
//#include <share.h>
#pragma warning(disable:4786)	// Disable warning: truncated debug information
#else // NOT WIN32
#include <assert.h>
#include <unistd.h>
#define Sleep(x) usleep(x * 1000)
#define ASSERT assert
#include "unixsock.h"
#endif // NOT WIN32

#ifdef SUNOS5
#define	NATIVE_ENDIAN	2
extern "C" int usleep(unsigned int useconds);
#endif // SUNOS5

#ifdef __VMS
#define	NATIVE_ENDIAN	1
#define NO_MUTABLE
#define NO_STD_NAMESPACE
#define binary 0
#endif // __VMS

#ifdef NO_MUTABLE
#define mutable
#define MAKE_MUTABLE(type) ((type*)(this))->
#else // NOT NO_MUTABLE
#define MAKE_MUTABLE(type) 
#endif // NOT NO_MUTABLE

#	include	"cctypes.h"
#	include	"safemem.h"
#	include	"util.h"
#	include	"array.h"

//#	include	"pqueue.thh"
//#	include	"pqueue.tcc"
//#	include	"farray.thh"
#	include	"buffer.hpp"	// modified file extension (.thh) [gz]

//#	include "zlib.h"

#include <algorithm>
#include <fstream>
#include <map>
#include <set>
#include <stdexcept>
#include <string>
#include <vector>
#include <utility>





// Sometimes it's easier to do something like this than guess
// for all the various systems.. 
#ifndef	SEEK_SET
#	define	SEEK_SET	0
#endif

