# Makefile
#
# Karl Franzens University Graz
# DICOM Network Transport Library UCDMC99
#
# System : OPENVMS 
# Endian : Little Endian


####################################################################

CXXDEBUG = /debug
CXXFLAGS = $(DEBUG) /assume=noheader_type_default /exceptions /nooptimize 
LIBR = LIBRARY
LINK = CXXLINK
LFLAG = $(DEBUG)

.SUFFIXES :	.obj .cpp .cxx

.cpp.obj :
	$(CXX) $(CXXFLAGS) $*.cpp

.cxx.obj :
	$(CXX) $(CXXFLAGS) $*.cxx

goal : ucdmc99.olb verify.exe serializer.exe storage.exe server_t.exe 

ucdmc99.olb : aaac.obj aarj.obj aarq.obj buffer.obj pdata.obj safemem.obj -
	socket.obj uniq.obj util.obj Cdimse.obj DataDict.obj DataSet.obj Decoder.obj -
	Decoder2.obj Dispatcher.obj Dumper.obj Encoder.obj Encoder2.obj -
	FileMetaInfo.obj DcmFile.obj Impl.obj MsgLogger.obj Ndimse.obj Server.obj -
	Parser.obj Pdu.obj StrTok.obj TS.obj
	$(LIBR) /CREATE $(MMS$TARGET) $(MMS$SOURCE_LIST)

verify.exe : verify.obj ucdmc99.olb
	$(LINK) $(LFLAG) verify.obj, ucdmc99/LIBRARY

serializer.exe :	Serializer.obj ucdmc99.olb
	$(LINK) $(LFLAG) Serializer.obj, ucdmc99/LIBRARY

storage.exe :	Storage.obj ucdmc99.olb
	$(LINK) $(LFLAG) Storage.obj, ucdmc99/LIBRARY

server_t.exe :	Server_t.obj ucdmc99.olb
	$(LINK) $(LFLAG) Server_t.obj, ucdmc99/LIBRARY

