#ifndef __SOCKET_HPP__
#define __SOCKET_HPP__
/****************************************************************************
          Copyright (C) 1995, University of California, Davis

          THIS SOFTWARE IS MADE AVAILABLE, AS IS, AND THE UNIVERSITY
          OF CALIFORNIA DOES NOT MAKE ANY WARRANTY ABOUT THE SOFTWARE, ITS
          PERFORMANCE, ITS MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR
          USE, FREEDOM FROM ANY COMPUTER DISEASES OR ITS CONFORMITY TO ANY
          SPECIFICATION. THE ENTIRE RISK AS TO QUALITY AND PERFORMANCE OF
          THE SOFTWARE IS WITH THE USER.

          Copyright of the software and supporting documentation is
          owned by the University of California, and free access
          is hereby granted as a license to use this software, copy this
          software and prepare derivative works based upon this software.
          However, any distribution of this software source code or
          supporting documentation or derivative works (source code and
          supporting documentation) must include this copyright notice.
****************************************************************************/

/***************************************************************************
 *
 * University of California, Davis
 * UCDMC DICOM Network Transport Libraries
 * Version 0.1 Beta
 *
 * Technical Contact: mhoskin@ucdavis.edu
 *
 ***************************************************************************/

/*********************************************************************
 *
 * Connection Class
 *
 *
 *********************************************************************/

// The library used to link with the DICOM Lib has a naming conflict with
// socket.  Therefor we simply remap our socket class into MacSocket.
 
#ifdef	MAC
#	define	Socket	MacSocket
#endif

class	Socket
	{
	int					Error;
	unsigned	long	tulong,*tulongptr;
	public:
    enum { ERR_TIMEOUT = -2, ERR_TCPCLOSE = -3 };
		int					Socketfd;
		int					ListenSocketfd;
		bool				UDP;
		bool				Connected;
		bool				Listened;
	private:
	struct	sockaddr_in	sa;
	struct	hostent		hes;
	struct	servent		servs;

		int					TimeOut;					
	public:
		virtual	bool	SendBinary(BYTE *, UINT);
		virtual	INT		ReadBinary(BYTE *, UINT);
		struct	hostent	*Gethostbyname(const char	*);
		struct	servent	*Getservbyname(const char	*, const char *);
		int		GetLinkError();
				Socket();
		virtual	~Socket();		
		virtual	bool	Open (const char *ip, const char *port );
		bool	Close ();
		int		GetLastError()	{ return ( Error ); };
		bool	Listen (const char *port);
		bool	Accept ();
		bool	SetTimeOut(int);
		
		// UDP Extensions
		bool	BindUDPServer(const char *port);
		bool	BindUDPClient(const char *host, const char *port);

	};


#endif //__SOCKET_HPP__